/*
								+---------------------------------+
								|                                 |
								|  ***   Lame common dlgs   ***  |
								|                                 |
								|  Copyright   -tHE SWINe- 2005  |
								|                                 |
								|           Dialogs.cpp           |
								|                                 |
								+---------------------------------+
*/

/*
 *	passed code revision at 2006-11-13
 *
 *	all integers, containing just true or false were replaced by bool
 *	added bool CLoggerDialog::AddLineF(const char *p_s_format_str, ...) function
 *	added function-documenting comments (todo)
 *	note it's possible to use GetModuleHandle(NULL) in DLL mode
 *
 *	passed code revision at 2007-03-06
 *
 *	removed __declspec(dllexport)
 *
 */

#include <vector>
#include "../berLame_src/CallStack.h"
#include <windows.h>
#include "DialogsRes.h"
#include "Dialogs.h"

#ifdef __UBERLAME_DLL
static HINSTANCE h_instance; // note it's possible to use GetModuleHandle(NULL)

BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	h_instance = hinstDLL;

	return TRUE;
}
// dll-main to obtain dll instance (necessary to access resources)
#endif //__UBERLAME_DLL

/*
 *								=== CLameDialog ===
 */

std::vector<CLameDialog*> *CLameDialog::m_p_dialog_list = 0;
CLameDialog *CLameDialog::m_p_recent_dialog;
CLameDialog *CLameDialog::m_p_dialog_being_created = 0;

CLameDialog::CLameDialog(int n_resource_id)
	:m_b_being_destroyed(false),
	m_n_resource_id(n_resource_id),
	m_h_dlg((HWND)0/*INVALID_HANDLE_VALUE*/)
{
	if(!m_p_dialog_list)
		m_p_dialog_list = new std::vector<CLameDialog*>;
	m_p_dialog_list->push_back(this);
	_ASSERTE(m_p_dialog_list->size());
	m_p_recent_dialog = this;
}

CLameDialog::~CLameDialog()
{
	if(m_h_dlg != 0/*INVALID_HANDLE_VALUE*/) {
		End();
	}
	for(int i = 0; i < m_p_dialog_list->size(); i ++) {
		if((*m_p_dialog_list)[i] == this) {
			m_p_dialog_list->erase(&(*m_p_dialog_list)[i]);
			if(!m_p_dialog_list->size()) {
				delete m_p_dialog_list;
				m_p_dialog_list = 0;
			}
			return;
		}
	}
	_ASSERTE(0); // it wasn't in the list
}

bool CLameDialog::Create(HWND h_parent, HINSTANCE h_instance)
{
	m_b_being_destroyed = false;
	m_p_dialog_being_created = this;
	// there are some messages sent before h_dlg is returned so we need
	// to know which dialog object we should link them to ...

	if((m_h_dlg = CreateDialog(h_instance, MAKEINTRESOURCE(m_n_resource_id),
	   h_parent, GlobalDlgProc)) == 0/*INVALID_HANDLE_VALUE*/) {
		int e = GetLastError();
		m_p_dialog_being_created = 0;
		return false;
	}
	m_p_dialog_being_created = 0;
	return true;
}

bool CLameDialog::End()
{
	m_b_being_destroyed = true;
	EndDialog(m_h_dlg, 0);
	m_h_dlg = (HWND)0/*INVALID_HANDLE_VALUE*/;

	return true;
}

bool CLameDialog::b_Created()
{
	return m_h_dlg != 0/*INVALID_HANDLE_VALUE*/;
}

int CALLBACK CLameDialog::GlobalDlgProc(HWND h_dlg, unsigned int n_msg,
	unsigned int n_w_param, long n_l_param)
{
	if(!m_p_recent_dialog || m_p_recent_dialog->m_h_dlg != h_dlg) {
		m_p_recent_dialog = 0;
		for(int i = 0; i < m_p_dialog_list->size(); i ++) {
			if((*m_p_dialog_list)[i]->m_h_dlg == h_dlg) {
				m_p_recent_dialog = (*m_p_dialog_list)[i];
				break;
			}
		}
	}
	// find appropriate window class ...

	if(!m_p_recent_dialog) {
		if(m_p_dialog_being_created) {
			m_p_recent_dialog = m_p_dialog_being_created;
			m_p_dialog_being_created->m_h_dlg = h_dlg;
		} else {
			//_ASSERTE(0);
			return 0;
		}
	}
	// may happen when we end dialog with some messages in queue

	if(m_p_recent_dialog->m_b_being_destroyed)
		return 0;
	return m_p_recent_dialog->DlgProc(h_dlg, n_msg, n_w_param, n_l_param);
}

/*
 *								=== ~CLameDialog ===
 */
