/*
								+---------------------------------+
								|                                 |
								|  ***   Lame common dlgs   ***  |
								|                                 |
								|  Copyright   -tHE SWINe- 2005  |
								|                                 |
								|            Dialogs.h            |
								|                                 |
								+---------------------------------+
*/

/*
 *	passed code revision at 2006-11-13
 *
 *	all integers, containing just true or false were replaced by bool
 *	added bool CLoggerDialog::AddLineF(const char *p_s_format_str, ...) function
 *	added function-documenting comments (todo)
 *	note it's possible to use GetModuleHandle(NULL) in DLL mode
 *
 *	passed code revision at 2007-03-06
 *
 *	removed __declspec(dllexport)
 *
 */

#ifndef __LAME_COMDLGS_INCLUDED
#define __LAME_COMDLGS_INCLUDED

class CLameDialog {
protected:
	static std::vector<CLameDialog*> *m_p_dialog_list;
	static CLameDialog *m_p_recent_dialog;
	static CLameDialog *m_p_dialog_being_created;

	HWND m_h_dlg;
	int m_n_resource_id;

	bool m_b_being_destroyed; // some glitches with messages sent after EndDialog()

public:
	CLameDialog(int n_resource_id);
	~CLameDialog();

	bool Create(HWND h_parent, HINSTANCE h_instance); // can use GetModuleHandle(NULL); to obtain h_instance
	bool End();

	void SetFocus() { if(b_Created()) ::SetFocus(m_h_dlg); }

	bool b_Created();

protected:
	static int CALLBACK GlobalDlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param);
	virtual int DlgProc(HWND h_dlg, unsigned int n_msg,
		unsigned int n_w_param, long n_l_param) = 0;
};

#endif //__LAME_COMDLGS_INCLUDED
